// structured bindings captures
// http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2019/p1091r3.html
#define HAS_STRUCTURED_BINDINGS_CAPTURES

// using enums
// http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2019/p1099r4.html
//#define HAS_USING_ENUMS

// String format library
// https://en.cppreference.com/w/cpp/utility/format
//#define HAS_FORMAT_LIBRARY

// Attributes
// https://en.cppreference.com/w/cpp/language/attributes
//#define HAS_C20_ATTRIBUTES

// Latches, barriers, and semaphores
// https://en.cppreference.com/w/cpp/thread
//#define HAS_LATCHES_BARRIERS

// Bit manipulation library
// https://en.cppreference.com/w/cpp/header/bit
//#define HAS_BITS_LIBRARY

// Calendar and time zones support
// https://en.cppreference.com/w/cpp/chrono
//#define HAS_CALENDAR_AND_TIMEZONES

// Span
// https://en.cppreference.com/w/cpp/container/span
//#define HAS_SPAN

// Joinable thread
// https://en.cppreference.com/w/cpp/thread/jthread
//#define HAS_JTHREAD

// std::atomic_ref
// https://en.cppreference.com/w/cpp/atomic/atomic_ref
//#define HAS_ATOMIC_REF

// consteval
// https://en.cppreference.com/w/cpp/language/consteval
//#define HAS_CONSTEVAL

// constinit
// https://en.cppreference.com/w/cpp/language/constinit
//#define HAS_CONSTINIT

// *_for_overwrite
// http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2020/p1973r1.pdf
//#define HAS_FOR_OVERWRITE

// requires clauses / expressions
// #define HAS_REQUIRES_EXPR
